<!-- 视频列表 -->
<template>
    <div class="table-box">
        <div style="padding-bottom: 16px">
            <el-button type="primary" @click="handleAdd"> 添加 </el-button>
        </div>
        <ProTable
            ref="proTableRef"
            :formData="dataStore.formData"
            :columns="dataStore.columns"
            :request-api="getVideoClassListApi"
            :init-param="dataStore.initParam"
        >
            <template #image="scope">
                <el-image :src="scope.row.image ? h + scope.row.image : ''" style="width: 60px; height: 60px" />
            </template>
            <template #status="scope">
                <el-tag type="success" effect="dark">{{ scope.row.status }}</el-tag>
            </template>
            <template #sort="scope">
                <el-input v-model="scope.row.sort" @blur="handleBlur(scope.row)" @input="handleInput(scope.row)"></el-input>
            </template>
            <template #operation="scope">
                <el-button size="small" type="primary" @click="handleBtnClick('编辑', scope.row)">编辑</el-button>
                <el-button size="small" type="danger" @click="handleBtnClick('删除', scope.row)">删除</el-button>
            </template>
        </ProTable>
        <el-drawer
            v-model="dataStore.visible"
            :show-close="true"
            :size="600"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :before-close="handleBeforeClone"
            destroy-on-close
        >
            <template #header="{ titleId, titleClass }">
                <h4 :id="titleId" :class="titleClass">{{ dataStore.title }}</h4>
            </template>
            <div>
                <rulesForm
                    :ruleForm="dataStore.editRuleForm"
                    :formData="dataStore.editFormData"
                    :rules="dataStore.rules"
                    ref="formRef"
                />
            </div>
            <template #footer>
                <div style="flex: auto">
                    <el-button @click="handleResetClick">重置</el-button>
                    <el-button type="primary" @click="handleConfirmClick">确认</el-button>
                </div>
            </template>
        </el-drawer>
    </div>
</template>

<script setup lang="ts" name="videoClassListIndex">
import ProTable from "@/components/ProTable/index.vue";
import rulesForm from "@/components/rulesForm/index.vue";
import { messageBox } from "@/utils/messageBox";
import { useMsg } from "@/hooks/useMsg";
import { integerRexg } from "@/utils/regexp/index";
//列表接口
import {
    getVideoClassListApi,
    getVideoClassListDelApi,
    getVideoClassReadApi,
    getVideoClassUpdateApi,
    getVideoClassSaveApi,
    getVideoClassSortApi
} from "@/api/modules/videoClass";
//深拷贝方法
import { cloneDeep } from "lodash-es";
import { h } from "@/utils/url";
//表格和搜索條件
import { RULE_FORM, FORM_DATA, COLUMNS, EDIT_FORM_DATA, EDIT_RULE_FORM, RULES } from "./constant/index";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const proTableRef = ref<any>(null);
const formRef: any = ref(null);
// 数据源
const dataStore = reactive<any>({
    title: "添加视频分类",
    columns: COLUMNS, //列表配置项
    rules: cloneDeep(RULES), //抽屉表单验证
    editRuleForm: cloneDeep(EDIT_RULE_FORM),
    editFormData: cloneDeep(EDIT_FORM_DATA), //抽屉表单配置项
    initParam: cloneDeep(RULE_FORM), // 初始化搜索条件|重置搜索条件
    ruleForm: cloneDeep(RULE_FORM), // 搜索參數
    formData: FORM_DATA, //搜索配置项
    visible: false,
    selectRow: {} //当前选择的row
});

//抽屉确认
const handleConfirmClick = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef!.validate((valid: any) => {
        if (valid) {
            console.log("submit!");
            dataStore.title === "编辑视频分类" ? getVideoClassUpdate() : getVideoClassSave();
        } else {
            console.log("error submit!");
            return false;
        }
    });
};
//重置验证状态
const resetFields = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef.resetFields();
};
//抽屉重置
const handleResetClick = () => {
    if (dataStore.title === "添加视频分类") {
        resetFields();
    } else {
        getVideoClassRead(dataStore.editRuleForm.id);
    }
};
//添加
const handleAdd = () => {
    dataStore.visible = true;
    dataStore.title = "添加视频分类";
};
const resetEditForm = () => {
    dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
};
const handleBeforeClone = () => {
    resetEditForm();
    console.log("12323");
    resetFields();
    dataStore.visible = false;
};
//更新
const getVideoClassUpdate = async () => {
    const result = await getVideoClassUpdateApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        useMsg("success", result?.msg);
        dataStore.visible = false;
        resetEditForm();
        proTableRef?.value?.getTableList();
    }
};
//保存
const getVideoClassSave = async () => {
    const result = await getVideoClassSaveApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        useMsg("success", result?.msg);
        dataStore.visible = false;
        resetEditForm();
        proTableRef?.value?.getTableList();
    }
};
//分类详情
const getVideoClassRead = async (id: any) => {
    const result = await getVideoClassReadApi(id);
    if (result?.code === 0) {
        dataStore.editRuleForm = result?.data;
        console.log(result?.data);
    }
};
//删除
const getVideoClassListDel = (id: any) => {
    messageBox("你确定要删除?", async () => {
        const result = await getVideoClassListDelApi(id);
        if (result?.code === 0) {
            const { msg } = result;
            useMsg("success", msg);
            proTableRef?.value?.getTableList();
        }
    });
};
//按钮点击事件
const handleBtnClick = (type: any, row: any) => {
    dataStore.selectRow = row;
    //编辑
    if (type === "编辑") {
        dataStore.visible = true;
        dataStore.title = "编辑视频分类";
        getVideoClassRead(row.id);
        return;
    }
    //删除
    if (type === "删除") {
        getVideoClassListDel(row.id);
    }
};

//排序
const getVideoClassSort = async (row: any) => {
    const result = await getVideoClassSortApi({ id: row.id, sort: row.sort });
    useMsg("success", result?.msg);
    if (result?.code === 0) {
        proTableRef?.value?.getTableList();
    }
};

//排序input框失焦
const handleBlur = (row: any) => {
    getVideoClassSort(row);
};
//排序input输入
const handleInput = (row: any) => {
    row.sort = integerRexg(row.sort);
};
</script>

<style scoped></style>
